import { world, GameMode } from '@minecraft/server';

world.afterEvents.itemUse.subscribe((event) =>{
    const player = event.source;
    const ItemStack = event.itemStack;
    const creative = GameMode['creative'];
    const durability = ItemStack.getComponent('minecraft:durability');
    const unbreakingLvl = ItemStack.getComponent('enchantable')?.getEnchantment('unbreaking')?.level ?? 0;

    if (player.matches({ gameMode: creative })) return;
    if (ItemStack.typeId !== "azonix:transit_gauntlet" && ItemStack.typeId !== "azonix:transit_staff" && ItemStack.typeId !== "azonix:spitter") return;
    if (ItemStack.typeId === "azonix:transit_gauntlet") {
        if (durability === undefined) return;
        if (1 / (unbreakingLvl + 1) < Math.random()) return;
        durability.damage = Math.min(durability.maxDurability, durability.damage + 1);
        if (durability.damage === durability.maxDurability) {
        player.getComponent('equippable').setEquipment('Mainhand', undefined);
        player.playSound("random.break", { location: player.location})
        } else {
        player.getComponent('equippable').setEquipment('Mainhand', ItemStack);
        }
    }
    if (ItemStack.typeId === "azonix:transit_staff") {
        if (player.isSneaking === false) {
            if (durability === undefined) return;
            if (1 / (unbreakingLvl + 1) < Math.random()) return;
            durability.damage = Math.min(durability.maxDurability, durability.damage + 3);
            if (durability.damage === durability.maxDurability) {
            player.getComponent('equippable').setEquipment('Mainhand', undefined);
            player.playSound("random.break", { location: player.location})
            } else {
            player.getComponent('equippable').setEquipment('Mainhand', ItemStack);
            }
        }
        if (player.isSneaking === true) {
            if (durability === undefined) return;
            if (1 / (unbreakingLvl + 1) < Math.random()) return;
            durability.damage = Math.min(durability.maxDurability, durability.damage + 6);
            if (durability.damage === durability.maxDurability) {
            player.getComponent('equippable').setEquipment('Mainhand', undefined);
            player.playSound("random.break", { location: player.location})
            } else {
            player.getComponent('equippable').setEquipment('Mainhand', ItemStack);
            }
        }
    }
    if (ItemStack.typeId === "azonix:spitter") {
        if (player.hasTag('arrow') || player.hasTag('snowball') || player.hasTag('egg') || player.hasTag('wind_charge') || (!player.hasTag('arrow') && !player.hasTag('snowball') && !player.hasTag('egg') && !player.hasTag('small_fireball') && !player.hasTag('fireball') && !player.hasTag('wind_charge') && !player.hasTag('shulker_bullet') && !player.hasTag('throwable_amethyst') && !player.hasTag('electric_spikeball') && !player.hasTag('wither_skull'))) {
            if (durability === undefined) return;
            if (1 / (unbreakingLvl + 1) < Math.random()) return;
            durability.damage = Math.min(durability.maxDurability, durability.damage + 1);
            if (durability.damage === durability.maxDurability) {
            player.getComponent('equippable').setEquipment('Mainhand', undefined);
            player.playSound("random.break", { location: player.location})
            } else {
            player.getComponent('equippable').setEquipment('Mainhand', ItemStack);
            }
            return;
        }
        if (player.hasTag('small_fireball') || player.hasTag('throwable_amethyst') || player.hasTag('electric_spikeball')) {
            if (durability === undefined) return;
            if (1 / (unbreakingLvl + 1) < Math.random()) return;
            durability.damage = Math.min(durability.maxDurability, durability.damage + 3);
            if (durability.damage === durability.maxDurability) {
            player.getComponent('equippable').setEquipment('Mainhand', undefined);
            player.playSound("random.break", { location: player.location})
            } else {
            player.getComponent('equippable').setEquipment('Mainhand', ItemStack);
            }
            return;
        }
        if (player.hasTag('fireball') || player.hasTag('shulker_bullet')) {
            if (durability === undefined) return;
            if (1 / (unbreakingLvl + 1) < Math.random()) return;
            durability.damage = Math.min(durability.maxDurability, durability.damage + 5);
            if (durability.damage === durability.maxDurability) {
            player.getComponent('equippable').setEquipment('Mainhand', undefined);
            player.playSound("random.break", { location: player.location})
            } else {
            player.getComponent('equippable').setEquipment('Mainhand', ItemStack);
            }
            return;
        }
        if (player.hasTag('wither_skull')) {
            if (durability === undefined) return;
            if (1 / (unbreakingLvl + 1) < Math.random()) return;
            durability.damage = Math.min(durability.maxDurability, durability.damage + 20);
            if (durability.damage === durability.maxDurability) {
            player.getComponent('equippable').setEquipment('Mainhand', undefined);
            player.playSound("random.break", { location: player.location})
            } else {
            player.getComponent('equippable').setEquipment('Mainhand', ItemStack);
            }
            return;
        }
    }
});