import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('azonix:on_interact', {
        onPlace: e => {
            const { block, player } = e;
            const { x, y, z } = block.location;
            if (e.block.typeId == "azonix:enderlock.actived") {
                e.block.dimension.runCommand(`/summon azonix:enderlock.entity ${x} ${y} ${z} ${y} ${x}`);
            }
        },
        onPlayerInteract: e => {
            const { block, player } = e;
            const { x, y, z } = block.location;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const random_chance = ["not_activated", "activated"];
            const chance = random_chance[Math.floor(Math.random() * random_chance.length)];

            if (selectedItem?.typeId === 'azonix:zircon_crystal_shard' && e.block.typeId == "azonix:enderlock") {
                if (chance === 'not_activated') {
                  console.warn('Not activated');
                  reduceItemAmount(selectedItem, equipment, player);
                  e.block.dimension.runCommand(`/playsound respawn_anchor.charge @a[r=16] ${x} ${y} ${z}1 1`);
                }
                else {
                  console.warn('Activated');
                  reduceItemAmount(selectedItem, equipment, player);
                  e.block.dimension.runCommand(`/playsound respawn_anchor.charge @a[r=16] ${x} ${y} ${z}1 1`);
                  e.block.dimension.runCommand(`/particle minecraft:basic_smoke_particle ${x} ${y + 1} ${z}`);
                  e.block.dimension.runCommand(`/playsound respawn_anchor.set_spawn @a[r=16] ${x} ${y} ${z}1 1`);
                  e.block.dimension.runCommand(`/setblock ${x} ${y} ${z} azonix:enderlock.actived`);
                }
            }
            if (e.block.typeId == "azonix:enderlock.actived") {
                e.block.dimension.runCommand(`/tp @e[family=!enderlock,family=player,c=1] @r[type=azonix:enderlock.entity,rm=1]`);
                e.block.dimension.runCommand(`/playsound portal.travel @a[r=16] ${x} ${y} ${z}1 1`);
                e.block.dimension.runCommand(`/playsound respawn_anchor.deplete @a[r=16] ${x} ${y} ${z}2 1`);
                e.block.dimension.runCommand(`/setblock ${x} ${y} ${z} azonix:enderlock`);
            }
        }
    });
});
function reduceItemAmount(item, equipment, player) {
    if (player.getGameMode() !== 'creative') {
        if (item.amount > 1) {
            item.amount -= 1;
            equipment.setEquipment('Mainhand', item);
        } else if (item.amount === 1) {
            equipment.setEquipment('Mainhand', undefined);
        }
    }
}