import { world, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('azonix:ticking_events', {
        onTick: e => {

            const { block } = e;
            const { x, y, z } = block.location;
            const above = block.above();
            const fade_level = block.permutation.getState("azonix:fade_level");

            if (block.typeId == "azonix:blomp_goo.baby_blue") {
                block.dimension.runCommand(`summon azonix:blomp_revive ${x} ${y} ${z} ${y} ${x} baby_blue`);
                block.setPermutation(BlockPermutation.resolve('minecraft:air'));
                return;
            }
            if (block.typeId == "azonix:blomp_goo.baby_pink") {
                block.dimension.runCommand(`summon azonix:blomp_revive ${x} ${y} ${z} ${y} ${x} baby_pink`);
                block.setPermutation(BlockPermutation.resolve('minecraft:air'));
                return;
            }
            if (block.typeId == "azonix:blomp_goo.baby_purple") {
                block.dimension.runCommand(`summon azonix:blomp_revive ${x} ${y} ${z} ${y} ${x} baby_purple`);
                block.setPermutation(BlockPermutation.resolve('minecraft:air'));
                return;
            }
            if (block.typeId == "azonix:blomp_goo.blue") {
                block.dimension.runCommand(`summon azonix:blomp_revive ${x} ${y} ${z} ${y} ${x} blue`);
                block.setPermutation(BlockPermutation.resolve('minecraft:air'));
                return;
            }
            if (block.typeId == "azonix:blomp_goo.pink") {
                block.dimension.runCommand(`summon azonix:blomp_revive ${x} ${y} ${z} ${y} ${x} pink`);
                block.setPermutation(BlockPermutation.resolve('minecraft:air'));
                return;
            }
            if (block.typeId == "azonix:blomp_goo.purple") {
                block.dimension.runCommand(`summon azonix:blomp_revive ${x} ${y} ${z} ${y} ${x} purple`);
                block.setPermutation(BlockPermutation.resolve('minecraft:air'));
                return;
            }
            if (block.typeId == "azonix:engrove_growths") {
                block.dimension.runCommand(`effect @e[family=!enderpillar,r=3] poison 5 1`);
                return;
            }
            if (block.typeId == "azonix:engrove_quills") {
                block.dimension.runCommand(`effect @e[family=!enderpillar,r=3] poison 5 1`);
                return;
            }
            if (block.typeId == "azonix:engrove_roots") {
                block.dimension.runCommand(`effect @e[family=!enderpillar,r=3] poison 5 1`);
                return;
            }
            if (block.typeId == "azonix:enderlock.actived") {
                above.dimension.spawnParticle("azonix:endlock_particle", block.location);
                return;
            }
            if (block.typeId == "azonix:zircon_crystal") {
                block.dimension.spawnParticle("azonix:crystal_sparkles", block.location);
                return;
            }
            if (block.typeId == "azonix:zircon_crystal_to_air_temp_block") {
                block.setPermutation(BlockPermutation.resolve('minecraft:air'));
            }
            if (block.typeId == "azonix:zircon_to_zircollium_temp_block") {
                block.setPermutation(BlockPermutation.resolve('azonix:zircollium_block'));
                return;
            }
            if (block.typeId == "azonix:jellix") {
                block.dimension.spawnParticle("azonix:mini_blomps", block.location);
                return;
            }
            if (block.typeId == "azonix:engrove_clover.fruit") {
                block.dimension.spawnParticle("azonix:end_glow", block.location);
                return;
            }
            if (block.typeId == "azonix:engrove_clover") {
                block.setPermutation(BlockPermutation.resolve('azonix:engrove_clover.fruit'));
                return;
            }
            if (block.typeId == "azonix:frobo_fern_top") {
                block.dimension.spawnParticle("azonix:bloom_spores", block.location);
                return;
            }
            if (block.typeId == "azonix:chorus_bush_top") {
                block.dimension.spawnParticle("azonix:end_spores", block.location);
                return;
            }
            if (block.typeId == "azonix:bounce_flower") {
                block.setPermutation(BlockPermutation.resolve('azonix:bounce_berry'));
                return;
            }
            if (block.typeId == "azonix:spectral_goo_block") {
                if (fade_level == 0) {
                    const above = block.above();
                    const below = block.below();
                    const north = block.north();
                    const south = block.south();
                    const east = block.east();
                    const west = block.west();
                    if(below.hasTag("spectral_goo_block.fade_level0")) {
                        block.setPermutation(block.permutation.withState('azonix:down', false));
                    }
                    else if (!below.hasTag("spectral_goo_block.fade_level0")) {
                        block.setPermutation(block.permutation.withState('azonix:down', true));
                    }
                    if(above.hasTag("spectral_goo_block.fade_level0")) {
                        block.setPermutation(block.permutation.withState('azonix:up', false));
                    }
                    else if(!above.hasTag("spectral_goo_block.fade_level0")) {
                        block.setPermutation(block.permutation.withState('azonix:up', true));
                    }
                    if(west.hasTag("spectral_goo_block.fade_level0")) {
                        block.setPermutation(block.permutation.withState('azonix:west', false));
                    }
                    else if(!west.hasTag("spectral_goo_block.fade_level0")) {
                        block.setPermutation(block.permutation.withState('azonix:west', true));
                    }
                    if(east.hasTag("spectral_goo_block.fade_level0")) {
                        block.setPermutation(block.permutation.withState('azonix:east', false));
                    }
                    else if(!east.hasTag("spectral_goo_block.fade_level0")) {
                        block.setPermutation(block.permutation.withState('azonix:east', true));
                    }
                    if(north.hasTag("spectral_goo_block.fade_level0")) {
                        block.setPermutation(block.permutation.withState('azonix:north', false));
                    }
                    else if(!north.hasTag("spectral_goo_block.fade_level0")) {
                        block.setPermutation(block.permutation.withState('azonix:north', true));
                    }
                    if(south.hasTag("spectral_goo_block.fade_level0")) {
                        block.setPermutation(block.permutation.withState('azonix:south', false));
                    }
                    else if(!south.hasTag("spectral_goo_block.fade_level0")) {
                        block.setPermutation(block.permutation.withState('azonix:south', true));
                    }
                    return;
                }
                if (fade_level == 1) {                
                    const above = block.above();
                    const below = block.below();
                    const north = block.north();
                    const south = block.south();
                    const east = block.east();
                    const west = block.west();
                    if(below.hasTag("spectral_goo_block.fade_level1")) {
                        block.setPermutation(block.permutation.withState('azonix:down', false));
                    }
                    else if (!below.hasTag("spectral_goo_block.fade_level1")) {
                        block.setPermutation(block.permutation.withState('azonix:down', true));
                    }
                    if(above.hasTag("spectral_goo_block.fade_level1")) {
                        block.setPermutation(block.permutation.withState('azonix:up', false));
                    }
                    else if(!above.hasTag("spectral_goo_block.fade_level1")) {
                        block.setPermutation(block.permutation.withState('azonix:up', true));
                    }
                    if(west.hasTag("spectral_goo_block.fade_level1")) {
                        block.setPermutation(block.permutation.withState('azonix:west', false));
                    }
                    else if(!west.hasTag("spectral_goo_block.fade_level1")) {
                        block.setPermutation(block.permutation.withState('azonix:west', true));
                    }
                    if(east.hasTag("spectral_goo_block.fade_level1")) {
                        block.setPermutation(block.permutation.withState('azonix:east', false));
                    }
                    else if(!east.hasTag("spectral_goo_block.fade_level1")) {
                        block.setPermutation(block.permutation.withState('azonix:east', true));
                    }
                    if(north.hasTag("spectral_goo_block.fade_level1")) {
                        block.setPermutation(block.permutation.withState('azonix:north', false));
                    }
                    else if(!north.hasTag("spectral_goo_block.fade_level1")) {
                        block.setPermutation(block.permutation.withState('azonix:north', true));
                    }
                    if(south.hasTag("spectral_goo_block.fade_level1")) {
                        block.setPermutation(block.permutation.withState('azonix:south', false));
                    }
                    else if(!south.hasTag("spectral_goo_block.fade_level1")) {
                        block.setPermutation(block.permutation.withState('azonix:south', true));
                    }
                    return;
                }
                if (fade_level == 2) {                
                    const above = block.above();
                    const below = block.below();
                    const north = block.north();
                    const south = block.south();
                    const east = block.east();
                    const west = block.west();
                    if(below.hasTag("spectral_goo_block.fade_level2")) {
                        block.setPermutation(block.permutation.withState('azonix:down', false));
                    }
                    else if (!below.hasTag("spectral_goo_block.fade_level2")) {
                        block.setPermutation(block.permutation.withState('azonix:down', true));
                    }
                    if(above.hasTag("spectral_goo_block.fade_level2")) {
                        block.setPermutation(block.permutation.withState('azonix:up', false));
                    }
                    else if(!above.hasTag("spectral_goo_block.fade_level2")) {
                        block.setPermutation(block.permutation.withState('azonix:up', true));
                    }
                    if(west.hasTag("spectral_goo_block.fade_level2")) {
                        block.setPermutation(block.permutation.withState('azonix:west', false));
                    }
                    else if(!west.hasTag("spectral_goo_block.fade_level2")) {
                        block.setPermutation(block.permutation.withState('azonix:west', true));
                    }
                    if(east.hasTag("spectral_goo_block.fade_level2")) {
                        block.setPermutation(block.permutation.withState('azonix:east', false));
                    }
                    else if(!east.hasTag("spectral_goo_block.fade_level2")) {
                        block.setPermutation(block.permutation.withState('azonix:east', true));
                    }
                    if(north.hasTag("spectral_goo_block.fade_level2")) {
                        block.setPermutation(block.permutation.withState('azonix:north', false));
                    }
                    else if(!north.hasTag("spectral_goo_block.fade_level2")) {
                        block.setPermutation(block.permutation.withState('azonix:north', true));
                    }
                    if(south.hasTag("spectral_goo_block.fade_level2")) {
                        block.setPermutation(block.permutation.withState('azonix:south', false));
                    }
                    else if(!south.hasTag("spectral_goo_block.fade_level2")) {
                        block.setPermutation(block.permutation.withState('azonix:south', true));
                    }
                    return;
                }
            }
        }
    });
})

