import { world, BlockPermutation } from "@minecraft/server"

const extraLargePlants = [
    { 
        id: "azonix:sodium_plant_bottom",
        middleBit: {
            id: "azonix:sodium_plant_middle"
        },
        topBit: {
            id: "azonix:sodium_plant_top"
        }
    }
]

world.afterEvents.playerPlaceBlock.subscribe(ev => {
    const above = ev.block.above();
    const aboveOne = ev.block.above(2);
    const matchingBottomPlant = extraLargePlants.find((plant) => ev.block.permutation.matches(plant.id));

    if (matchingBottomPlant != undefined && above.isAir && aboveOne.isAir) {
        const matchingMiddlePlantId = matchingBottomPlant.middleBit.id;
        above.setPermutation(BlockPermutation.resolve(matchingMiddlePlantId));
        const matchingTopPlantId = matchingBottomPlant.topBit.id;
        aboveOne.setPermutation(BlockPermutation.resolve(matchingTopPlantId));
    } else if (matchingBottomPlant != undefined && ((!above.isAir && !aboveOne.isAir) || (above.isAir && !aboveOne.isAir) || (!above.isAir && aboveOne.isAir))) {
        const { x, y, z } = ev.block.location;
        ev.dimension.runCommand(`setblock ${x} ${y} ${z} air[] destroy`);
    }
})

world.afterEvents.playerBreakBlock.subscribe(ev => {
    const matchingMiddlePlant = extraLargePlants.find((plant) => ev.brokenBlockPermutation.matches(plant.middleBit.id));
    const matchingTopPlant = extraLargePlants.find((plant) => ev.brokenBlockPermutation.matches(plant.topBit.id));
    if (matchingTopPlant) {
        const { x, y, z } = ev.block.location;
        ev.dimension.runCommand(`setblock ${x} ${y - 2} ${z} air[] destroy`);
    }
    if (matchingMiddlePlant) {
        const { x, y, z } = ev.block.location;
        ev.dimension.runCommand(`setblock ${x} ${y - 1} ${z} air[] destroy`);
    }
})
