import { Block } from "@minecraft/server";

const fenceTag = 'is_fence'

export class fence_Manager {
    static update_Fence_States(Fence) {
        let north = undefined;
        try {
            north = Fence.north(1);
        } catch { }
        let south = undefined;
        try {
            south = Fence.south(1);
        } catch { }
        let east = undefined;
        try {
            east = Fence.east(1);
        } catch { }
        let west = undefined;
        try {
            west = Fence.west(1);
        } catch { }
        const blocks = [
            { block: north, side: "north" },
            { block: south, side: "south" },
            { block: east, side: "east" },
            { block: west, side: "west" },
        ];
        for (const blockData of blocks) {
            if (blockData.block != undefined) {
                if (!(blockData.block.isLiquid || blockData.block.isAir || blockData.block.permutation.matches('minecraft:glow_lichen') || blockData.block.permutation.matches('minecraft:carpet') || blockData.block.permutation.matches('minecraft:ladder') || blockData.block.permutation.matches('minecraft:trip_wire') || blockData.block.permutation.matches('minecraft:acacia_leaves') || blockData.block.permutation.matches('minecraft:azalea_leaves') || blockData.block.permutation.matches('minecraft:azalea_leaves_flowered') || blockData.block.permutation.matches('minecraft:birch_leaves') || blockData.block.permutation.matches('minecraft:cherry_leaves') || blockData.block.permutation.matches('minecraft:dark_oak_leaves') || blockData.block.permutation.matches('minecraft:jungle_leaves') || blockData.block.permutation.matches('minecraft:mangrove_leaves') || blockData.block.permutation.matches('minecraft:oak_leaves') || blockData.block.permutation.matches('minecraft:spruce_leaves') || blockData.block.permutation.matches('minecraft:reeds') || blockData.block.permutation.matches('minecraft:sweet_berry_bush') || blockData.block.permutation.matches('minecraft:vine') || blockData.block.permutation.matches('minecraft:fern') || blockData.block.permutation.matches('minecraft:large_fern') || blockData.block.permutation.matches('minecraft:crimson_roots') || blockData.block.permutation.matches('minecraft:warped_roots') || blockData.block.permutation.matches('minecraft:poppy') || blockData.block.permutation.matches('minecraft:blue_orchid') || blockData.block.permutation.matches('minecraft:allium') || blockData.block.permutation.matches('minecraft:azure_bluet') || blockData.block.permutation.matches('minecraft:red_tulip') || blockData.block.permutation.matches('minecraft:orange_tulip') || blockData.block.permutation.matches('minecraft:white_tulip') || blockData.block.permutation.matches('minecraft:pink_tulip') || blockData.block.permutation.matches('minecraft:oxeye_daisy') || blockData.block.permutation.matches('minecraft:lily_of_the_valley') || blockData.block.permutation.matches('minecraft:lilac') || blockData.block.permutation.matches('minecraft:rose_bush') || blockData.block.permutation.matches('minecraft:peony') || blockData.block.permutation.matches('minecraft:wither_rose') || blockData.block.permutation.matches('minecraft:closed_eyeblossom') || blockData.block.permutation.matches('minecraft:open_eyeblossom') || blockData.block.permutation.matches('minecraft:deadbush') || blockData.block.permutation.matches('minecraft:pumpkin') || blockData.block.permutation.matches('minecraft:carved_pumpkin') || blockData.block.permutation.matches('minecraft:lit_pumpkin') || blockData.block.permutation.matches('minecraft:pointed_dripstone') || blockData.block.permutation.matches('minecraft:small_amethyst_bud') || blockData.block.permutation.matches('minecraft:medium_amethyst_bud') || blockData.block.permutation.matches('minecraft:large_amethyst_bud') || blockData.block.permutation.matches('minecraft:amethyst_cluster') || blockData.block.permutation.matches('minecraft:dandelion') || blockData.block.permutation.matches('minecraft:sunflower') || blockData.block.permutation.matches('minecraft:torchflower') || blockData.block.permutation.matches('minecraft:cornflower') || blockData.block.permutation.matches('minecraft:flowering_azalea') || blockData.block.permutation.matches('minecraft:azalea') || blockData.block.permutation.matches('minecraft:pale_oak_leaves') || blockData.block.permutation.matches('minecraft:pale_moss_carpet') || blockData.block.permutation.matches('minecraft:pale_hanging_moss') || blockData.block.permutation.matches('minecraft:bamboo') || blockData.block.permutation.matches('minecraft:mangrove_propagule') || blockData.block.permutation.matches('minecraft:moss_carpet') || blockData.block.permutation.matches('minecraft:brown_mushroom') || blockData.block.permutation.matches('minecraft:red_mushroom') || blockData.block.permutation.matches('minecraft:bamboo_sapling') || blockData.block.permutation.matches('minecraft:snow_layer') || blockData.block.permutation.matches('minecraft:torch') || blockData.block.permutation.matches('minecraft:weeping_vines') || blockData.block.permutation.matches('minecraft:twisting_vines') || blockData.block.permutation.matches('minecraft:pink_petals') || blockData.block.permutation.matches('minecraft:tall_grass') || blockData.block.permutation.matches('minecraft:short_grass') || blockData.block.hasTag('rail') || blockData.block.hasTag('not_feature_replaceable') || blockData.block.hasTag('not_a_full_block') || blockData.block.hasTag('is_wall') || blockData.block.hasTag('text_sign') || blockData.block.hasTag('minecraft:crop') || blockData.block.hasTag('plant'))) {
                    Fence.setPermutation(Fence.permutation.withState("azonix:connect_" + blockData.side, true));
                } else {
                    Fence.setPermutation(Fence.permutation.withState("azonix:connect_" + blockData.side, false));
                }
            } else {
                Fence.setPermutation(Fence.permutation.withState("azonix:connect_" + blockData.side, false));
            }
        }
    }
    static updateFencesAround(Block) {
        let north = undefined;
        try {
            north = Block.north(1);
        } catch { }
        let south = undefined;
        try {
            south = Block.south(1);
        } catch { }
        let east = undefined;
        try {
            east = Block.east(1);
        } catch { }
        let west = undefined;
        try {
            west = Block.west(1);
        } catch { }
        const blocks = [Block, north, south, east, west];
        for (const block of blocks) {
            if (block != undefined) {
                if (block.hasTag(fenceTag)) this.update_Fence_States(block);
            }
        }
    }
}
