import { world, BlockPermutation } from "@minecraft/server"

const hangingPlants = [
    { 
        id: "azonix:chorus_vine",
        headBit: {
            id: "azonix:chorus_lamp"
        }
    }
]

world.afterEvents.playerPlaceBlock.subscribe(ev => {
    const below = ev.block.below();

    const matchingTopPlant = hangingPlants.find((plant) => ev.block.permutation.matches(plant.id));

    if (matchingTopPlant != undefined && below.isAir) {
        const matchingBottomPlantId = matchingTopPlant.headBit.id;
        below.setPermutation(BlockPermutation.resolve(matchingBottomPlantId));
    } else if (matchingTopPlant != undefined && !below.isAir) {
        const { x, y, z } = ev.block.location;
        ev.dimension.runCommand(`setblock ${x} ${y} ${z} air[] destroy`);
    }
})

world.afterEvents.playerBreakBlock.subscribe(ev => {
    const matchingBottomPlant = hangingPlants.find((plant) => ev.brokenBlockPermutation.matches(plant.headBit.id));
    if (matchingBottomPlant) {
        const { x, y, z } = ev.block.location;
        ev.dimension.runCommand(`setblock ${x} ${y + 1} ${z} air[] destroy`);
    }
})
