import { world } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.itemComponentRegistry.registerCustomComponent("azonix:on_use", {
        onUse(event) {
            const player = event.source;
            const { x, y, z } = player.location;
            const ItemStack = event.itemStack;
            const arrow_sound = 'crossbow.shoot';
            const bow_sound = 'mob.snowgolem.shoot';
            const blaze_sound = 'mob.blaze.shoot';
            const breeze_sound = 'mob.breeze.shoot';
            const wither_sound = 'mob.wither.shoot';
            const amethyst_sound = 'hit.amethyst_cluster';
            const amethyst_chime_sound = 'chime.amethyst_block';
            const shulker_sound = 'mob.shulker.shoot';
            const spyglass_sound = 'item.spyglass.use';
            const spikeball_sound = 'firework.launch';

            if (ItemStack.typeId === 'azonix:transit_gauntlet') {
                console.warn('Used Transit Gauntlet');
                let launchVel=1;
                const velocity = player.getViewDirection();
                let headLoc=player.getHeadLocation();
                const projectile = player.dimension.spawnEntity('azonix:electric_spikeball', {x: headLoc.x+velocity.x, y: headLoc.y+velocity.y, z: headLoc.z+velocity.z});
                const projectileComp = projectile.getComponent('minecraft:projectile');
                projectileComp?.shoot({x: velocity.x*launchVel, y: velocity.y*launchVel, z: velocity.z*launchVel});
                player.runCommand(`playsound ${spikeball_sound} @a[r=16] ${x} ${y} ${z} 1.0 0.8`);
            }
            if (ItemStack.typeId === 'azonix:transit_staff' && player.isSneaking === false) {
                console.warn('Used Transit Staff');
                let launchVel=1;
                const velocity = player.getViewDirection();
                let headLoc=player.getHeadLocation();
                const projectile = player.dimension.spawnEntity('azonix:throwable_amy', {x: headLoc.x+velocity.x, y: headLoc.y+velocity.y, z: headLoc.z+velocity.z});
                const projectileComp = projectile.getComponent('minecraft:projectile');
                projectileComp?.shoot({x: velocity.x*launchVel, y: velocity.y*launchVel, z: velocity.z*launchVel});
                player.runCommand(`playsound ${spyglass_sound} @a[r=16] ${x} ${y} ${z} 2 1`);
            }
            if (ItemStack.typeId === 'azonix:transit_staff' && player.isSneaking === true) {
                console.warn('Used Transit Staff While Sneaking');
                player.runCommand(`playsound ${amethyst_chime_sound} @a[r=16] ${x} ${y} ${z} 2 1`);
                player.runCommand(`effect @s levitation 1 10`);
                player.runCommand(`effect @s slow_falling 10 1`);
            }
            if (ItemStack.typeId === 'azonix:spitter') {
                console.warn('Used Spitter');
                if (player.isSneaking === true) {
                    player.runCommand(`playsound ${spyglass_sound} @a[r=16] ${x} ${y} ${z} 2 1`);
                    if (player.hasTag('arrow') || (!player.hasTag('arrow') && !player.hasTag('snowball') && !player.hasTag('egg') && !player.hasTag('small_fireball') && !player.hasTag('fireball') && !player.hasTag('wind_charge') && !player.hasTag('shulker_bullet') && !player.hasTag('throwable_amethyst') && !player.hasTag('electric_spikeball') && !player.hasTag('wither_skull'))) {
                        player.addTag('snowball')
                        player.runCommand(`titleraw @s actionbar {"rawtext":[{"translate":"switch.snowball"}]}`)
                        if (player.hasTag('arrow')) {
                            player.removeTag('arrow')
                        }
                        return;
                    }
                    if (player.hasTag('snowball')) {
                        player.addTag('egg')
                        player.runCommand(`titleraw @s actionbar {"rawtext":[{"translate":"switch.egg"}]}`)
                        player.removeTag('snowball')
                        return;
                    }
                    if (player.hasTag('egg')) {
                        player.addTag('small_fireball')
                        player.runCommand(`titleraw @s actionbar {"rawtext":[{"translate":"switch.small_fireball"}]}`)
                        player.removeTag('egg')
                        return;
                    }
                    if (player.hasTag('small_fireball')) {
                        player.addTag('fireball')
                        player.runCommand(`titleraw @s actionbar {"rawtext":[{"translate":"switch.fireball"}]}`)
                        player.removeTag('small_fireball')
                        return;
                    }
                    if (player.hasTag('fireball')) {
                        player.addTag('wind_charge')
                        player.runCommand(`titleraw @s actionbar {"rawtext":[{"translate":"switch.wind_charge"}]}`)
                        player.removeTag('fireball')
                        return;
                    }
                    if (player.hasTag('wind_charge')) {
                        player.addTag('shulker_bullet')
                        player.runCommand(`titleraw @s actionbar {"rawtext":[{"translate":"switch.shulker_bullet"}]}`)
                        player.removeTag('wind_charge')
                        return;
                    }
                    if (player.hasTag('shulker_bullet')) {
                        player.addTag('throwable_amethyst')
                        player.runCommand(`titleraw @s actionbar {"rawtext":[{"translate":"switch.throwable_amethyst"}]}`)
                        player.removeTag('shulker_bullet')
                        return;
                    }
                    if (player.hasTag('throwable_amethyst')) {
                        player.addTag('electric_spikeball')
                        player.runCommand(`titleraw @s actionbar {"rawtext":[{"translate":"switch.electric_spikeball"}]}`)
                        player.removeTag('throwable_amethyst')
                        return;
                    }
                    if (player.hasTag('electric_spikeball')) {
                        player.addTag('wither_skull')
                        player.runCommand(`titleraw @s actionbar {"rawtext":[{"translate":"switch.wither_skull"}]}`)
                        player.removeTag('electric_spikeball')
                        return;
                    }
                    if (player.hasTag('wither_skull')) {
                        player.addTag('arrow')
                        player.runCommand(`titleraw @s actionbar {"rawtext":[{"translate":"switch.arrow"}]}`)
                        player.removeTag('wither_skull')
                        return;
                    }
                }
                if (player.isSneaking === false) {
                    let launchVel=1;
                    const velocity = player.getViewDirection();
                    let headLoc= player.getHeadLocation();
                    if (player.hasTag('arrow') || (!player.hasTag('arrow') && !player.hasTag('snowball') && !player.hasTag('egg') && !player.hasTag('small_fireball') && !player.hasTag('fireball') && !player.hasTag('wind_charge') && !player.hasTag('shulker_bullet') && !player.hasTag('throwable_amethyst') && !player.hasTag('electric_spikeball') && !player.hasTag('wither_skull'))) {
                        const projectile = player.dimension.spawnEntity('minecraft:arrow', {x: headLoc.x+velocity.x, y: headLoc.y+velocity.y, z: headLoc.z+velocity.z});
                        const projectileComp = projectile.getComponent('minecraft:projectile');
                        projectileComp?.shoot({x: velocity.x*launchVel, y: velocity.y*launchVel, z: velocity.z*launchVel});
                        player.runCommand(`playsound ${arrow_sound} @a[r=16] ${x} ${y} ${z} 1 1`);
                        return;
                    }
                    if (player.hasTag('snowball')) {
                        const projectile = player.dimension.spawnEntity('minecraft:snowball', {x: headLoc.x+velocity.x, y: headLoc.y+velocity.y, z: headLoc.z+velocity.z});
                        const projectileComp = projectile.getComponent('minecraft:projectile');
                        projectileComp?.shoot({x: velocity.x*launchVel, y: velocity.y*launchVel, z: velocity.z*launchVel});
                        player.runCommand(`playsound ${bow_sound} @a[r=16] ${x} ${y} ${z} 1 1`);
                        return;
                    }
                    if (player.hasTag('egg')) {
                        const projectile = player.dimension.spawnEntity('minecraft:egg', {x: headLoc.x+velocity.x, y: headLoc.y+velocity.y, z: headLoc.z+velocity.z});
                        const projectileComp = projectile.getComponent('minecraft:projectile');
                        projectileComp?.shoot({x: velocity.x*launchVel, y: velocity.y*launchVel, z: velocity.z*launchVel});
                        player.runCommand(`playsound ${bow_sound} @a[r=16] ${x} ${y} ${z} 1 1`);
                        return;
                    }
                    if (player.hasTag('small_fireball')) {
                        const projectile = player.dimension.spawnEntity('minecraft:small_fireball', {x: headLoc.x+velocity.x, y: headLoc.y+velocity.y, z: headLoc.z+velocity.z});
                        const projectileComp = projectile.getComponent('minecraft:projectile');
                        projectileComp?.shoot({x: velocity.x*launchVel, y: velocity.y*launchVel, z: velocity.z*launchVel});
                        player.runCommand(`playsound ${blaze_sound} @a[r=16] ${x} ${y} ${z} 1 1`);
                        return;
                    }
                    if (player.hasTag('fireball')) {
                        const projectile = player.dimension.spawnEntity('minecraft:fireball', {x: headLoc.x+velocity.x, y: headLoc.y+velocity.y, z: headLoc.z+velocity.z});
                        const projectileComp = projectile.getComponent('minecraft:projectile');
                        projectileComp?.shoot({x: velocity.x*launchVel, y: velocity.y*launchVel, z: velocity.z*launchVel});
                        player.runCommand(`playsound ${blaze_sound} @a[r=16] ${x} ${y} ${z} 1 1`);
                        return;
                    }
                    if (player.hasTag('wind_charge')) {
                        const projectile = player.dimension.spawnEntity('minecraft:wind_charge_projectile', {x: headLoc.x+velocity.x, y: headLoc.y+velocity.y, z: headLoc.z+velocity.z});
                        const projectileComp = projectile.getComponent('minecraft:projectile');
                        projectileComp?.shoot({x: velocity.x*launchVel, y: velocity.y*launchVel, z: velocity.z*launchVel});
                        player.runCommand(`playsound ${breeze_sound} @a[r=16] ${x} ${y} ${z} 1 1`);
                        return;
                    }
                    if (player.hasTag('shulker_bullet')) {
                        player.runCommand(`summon azonix:bullet_shooter ${x} ${y} ${z}`);
                        player.runCommand(`playsound ${shulker_sound} @a[r=16] ${x} ${y} ${z} 1 1`);
                        return;
                    }
                    if (player.hasTag('throwable_amethyst')) {
                        const projectile = player.dimension.spawnEntity('azonix:throwable_amy', {x: headLoc.x+velocity.x, y: headLoc.y+velocity.y, z: headLoc.z+velocity.z});
                        const projectileComp = projectile.getComponent('minecraft:projectile');
                        projectileComp?.shoot({x: velocity.x*launchVel, y: velocity.y*launchVel, z: velocity.z*launchVel});
                        player.runCommand(`playsound ${amethyst_sound} @a[r=16] ${x} ${y} ${z} 1 1`);
                        return;
                    }
                    if (player.hasTag('electric_spikeball')) {
                        const projectile = player.dimension.spawnEntity('azonix:electric_spikeball', {x: headLoc.x+velocity.x, y: headLoc.y+velocity.y, z: headLoc.z+velocity.z});
                        const projectileComp = projectile.getComponent('minecraft:projectile');
                        projectileComp?.shoot({x: velocity.x*launchVel, y: velocity.y*launchVel, z: velocity.z*launchVel});
                        player.runCommand(`playsound ${spikeball_sound} @a[r=16] ${x} ${y} ${z} 2 0.8`);
                        return;
                    }
                    if (player.hasTag('wither_skull')) {
                        const projectile = player.dimension.spawnEntity('minecraft:wither_skull', {x: headLoc.x+velocity.x, y: headLoc.y+velocity.y, z: headLoc.z+velocity.z});
                        const projectileComp = projectile.getComponent('minecraft:projectile');
                        projectileComp?.shoot({x: velocity.x*launchVel, y: velocity.y*launchVel, z: velocity.z*launchVel});
                        player.runCommand(`playsound ${wither_sound} @a[r=16] ${x} ${y} ${z} 2 0.8`);
                        return;
                    }
                }
            }
        },
    });
});