import { system, world } from '@minecraft/server';

const chorushuffleMusicDisc = [
    'azonix:music_disc_chorushuffle'
];

world.beforeEvents.playerInteractWithBlock.subscribe(evd => {
    const { player, itemStack, block } = evd;

    if (!block.permutation.matches('minecraft:jukebox')) return;

    if (itemStack) {
        if (chorushuffleMusicDisc.includes(itemStack.typeId)) {
            system.run(function () {
                block.dimension.playSound("record.chorushuffle", block.location)
            })
            return;
        }
    }
    system.run(function () {
        player.runCommand(`stopsound @a record.chorushuffle`);
    })
})

world.afterEvents.playerBreakBlock.subscribe(evd => {
    const { player, brokenBlockPermutation } = evd;

    if (!brokenBlockPermutation.matches('minecraft:jukebox')) return;
    player.runCommand(`stopsound @a record.chorushuffle`);
})