import { world, ItemStack } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent('azonix:on_player_destroy', {
        onPlayerDestroy: (event) => {
            const { player, dimension, block, destroyedBlockPermutation: perm } = event;
            if (!player || !player.getComponent('equippable')) {
                return;
            }
            const selectedItem = player.getComponent('equippable').getEquipment('Mainhand');
            if(!block.hasTag('wood')) {
                if (!selectedItem || !selectedItem.hasTag('minecraft:is_pickaxe')) {
                    return;
                }
            }
            const slabItem = perm.getItemStack(1);
            if (slabItem) {
                dimension.spawnItem(slabItem, block.location);
            }
        }
    });
});