import { world, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('azonix:on_random_tick', {
        onRandomTick: e => {
            const { block } = e;
            const fade_level = block.permutation.getState("azonix:fade_level");
            if (block.typeId == "azonix:mycotic_growth_temp") {
                block.setPermutation(BlockPermutation.resolve('azonix:mycotic_growth', {'minecraft:block_face': 'up'}));
            }
            if (block.typeId == "azonix:spectral_goo_block_temp") {
                if (fade_level == 0) {
                    block.setPermutation(BlockPermutation.resolve('azonix:spectral_goo_block', {'azonix:fade_level': 0}));
                }
                if (fade_level == 1) {
                    block.setPermutation(BlockPermutation.resolve('azonix:spectral_goo_block', {'azonix:fade_level': 1}));
                }
                if (fade_level == 2) {
                    block.setPermutation(BlockPermutation.resolve('azonix:spectral_goo_block', {'azonix:fade_level': 2}));
                }
            }
            if (block.typeId == "azonix:jellix_temp") {
                block.setType('azonix:jellix');
            }
            if (block.typeId == "azonix:frobo_fern_bottom_temp") {
                block.setType('azonix:frobo_fern_bottom');
                block.above().setType('azonix:frobo_fern_top');
            }
            if (block.typeId == "azonix:frobo_fern_top_temp") {
                block.below().setType('azonix:frobo_fern_bottom');
                block.setType('azonix:frobo_fern_top');
            }
            if (block.typeId == "azonix:chorus_bush_bottom_temp") {
                block.setType('azonix:chorus_bush_bottom');
                block.above().setType('azonix:chorus_bush_top');
            }
            if (block.typeId == "azonix:chorus_bush_top_temp") {
                block.below().setType('azonix:chorus_bush_bottom');
                block.setType('azonix:chorus_bush_top');
            }
            if (block.typeId == "azonix:engrove_clover.fruit_temp") {
                block.setType('azonix:engrove_clover.fruit');
            }
        }
    });
})