import { world, BlockPermutation, Player } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('azonix:on_step', {
        onStepOn: (event) => {
            const { block, entity: player } = event;
            if (!(player instanceof Player)) return;
            const item = player.getComponent('equippable').getEquipment('Feet');
            const fade_level = block.permutation.getState("azonix:fade_level");

            if (block.typeId === 'azonix:spectral_goo_block' && item?.typeId !== 'azonix:spectral_boots' && fade_level == 0) {
                block.dimension.playSound('spread.sculk', block.location);
                block.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 1 }))
            }
        },
        onEntityFallOn: (event) => {
            const { block, entity: player } = event;
            if (!(player instanceof Player)) return;
            const item = player.getComponent('equippable').getEquipment('Feet');
            const below = block.below();
            const north = block.north();
            const south = block.south();
            const east = block.east();
            const west = block.west();
            const below_north = below.north();
            const below_south = below.south();
            const below_east = below.east();
            const below_west = below.west();

            if (event.fallDistance > 3 && event.fallDistance < 6 && block.typeId === 'azonix:spectral_goo_block' && item?.typeId !== 'azonix:spectral_boots') {
                console.warn('fall(>3) event executed');
                block.dimension.playSound('spread.sculk', block.location);
                block.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 2 }))
                if (north.typeId === 'azonix:spectral_goo_block') {
                    north.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 2}))
                    console.warn('setPermutation, north executed');
                }
                if (south.typeId === 'azonix:spectral_goo_block') {
                    south.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 2}))
                    console.warn('setPermutation, south executed');
                }
                if (east.typeId === 'azonix:spectral_goo_block') {
                    east.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 2}))
                    console.warn('setPermutation, east executed');
                }
                if (west.typeId === 'azonix:spectral_goo_block') {
                    west.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 2}))
                    console.warn('setPermutation, west executed');
                }
            }
            if (event.fallDistance > 6 && event.fallDistance < 12 && block.typeId === 'azonix:spectral_goo_block' && item?.typeId !== 'azonix:spectral_boots') {
                console.warn('fall(>6) event executed');
                block.dimension.playSound('spread.sculk', block.location);
                block.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3 }))
                if (north.typeId === 'azonix:spectral_goo_block') {
                    north.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, north executed');
                }
                if (south.typeId === 'azonix:spectral_goo_block') {
                    south.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, south executed');
                }
                if (east.typeId === 'azonix:spectral_goo_block') {
                    east.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, east executed');
                }
                if (west.typeId === 'azonix:spectral_goo_block') {
                    west.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, west executed');
                }
                if (below.typeId === 'azonix:spectral_goo_block') {
                    below.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 2}))
                    console.warn('setPermutation, below executed');
                }
                if (below_north.typeId === 'azonix:spectral_goo_block') {
                    below_north.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 2}))
                    console.warn('setPermutation, below north executed');
                }
                if (below_south.typeId === 'azonix:spectral_goo_block') {
                    below_south.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 2}))
                    console.warn('setPermutation, below south executed');
                }
                if (below_east.typeId === 'azonix:spectral_goo_block') {
                    below_east.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 2}))
                    console.warn('setPermutation, below east executed');
                }
                if (below_west.typeId === 'azonix:spectral_goo_block') {
                    below_west.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 2}))
                    console.warn('setPermutation, below west executed');
                }
            }
            if (event.fallDistance > 5 && block.typeId === 'azonix:spectral_goo_block' && item?.typeId !== 'azonix:spectral_boots') {
                console.warn('fall(>12) event executed');
                block.dimension.playSound('spread.sculk', block.location);
                block.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3 }))
                if (north.typeId === 'azonix:spectral_goo_block') {
                    north.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, north executed');
                }
                if (south.typeId === 'azonix:spectral_goo_block') {
                    south.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, south executed');
                }
                if (east.typeId === 'azonix:spectral_goo_block') {
                    east.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, east executed');
                }
                if (west.typeId === 'azonix:spectral_goo_block') {
                    west.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, west executed');
                }
                if (below.typeId === 'azonix:spectral_goo_block') {
                    below.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, below executed');
                }
                if (below_north.typeId === 'azonix:spectral_goo_block') {
                    below_north.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, below north executed');
                }
                if (below_south.typeId === 'azonix:spectral_goo_block') {
                    below_south.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, below south executed');
                }
                if (below_east.typeId === 'azonix:spectral_goo_block') {
                    below_east.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, below east executed');
                }
                if (below_west.typeId === 'azonix:spectral_goo_block') {
                    below_west.setPermutation(BlockPermutation.resolve("azonix:spectral_goo_block", { "azonix:fade_level": 3}))
                    console.warn('setPermutation, below west executed');
                }
            }
        }
    });
})