import { world, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('azonix:plant_functions', {
        onPlayerInteract: e => {
            const { block, player } = e;
            const { x, y, z } = block.location;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            const aboveBlock = block.above();
            const belowBlock = block.below();
            const belowBlockOne = block.below(2);
            const randomChance = Math.random();

            if (selectedItem?.typeId === 'minecraft:bone_meal') {
                if (e.block.typeId == "azonix:puffle_sapling") {
                  reduceItemAmount(selectedItem, equipment, player);
                  e.block.dimension.playSound('item.bone_meal.use', e.block.location);
                  e.block.dimension.runCommand(`particle minecraft:crop_growth_emitter ${x} ${y} ${z}`);
                  if (randomChance <= 6/10) return;
                  else {
                    block.setPermutation(BlockPermutation.resolve("minecraft:air"));
                    if (randomChance <= 1/5) {
                      e.block.dimension.runCommand(`structure load mystructure:puffle_tree1 ${x - 3} ${y} ${z - 3}`);
                    }
                    else if (randomChance <= 2/5) {
                      e.block.dimension.runCommand(`structure load mystructure:puffle_tree2 ${x - 4} ${y} ${z - 4}`);
                    }
                    else if (randomChance <= 3/5) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:puffle_tree3 ${x - 2} ${y} ${z - 2}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:puffle_tree3 ${x - 2} ${y} ${z - 2} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:puffle_tree3 ${x - 2} ${y} ${z - 2} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:puffle_tree3 ${x - 2} ${y} ${z - 2} 90_degrees`);
                      }
                    }
                    else if (randomChance <= 4/5) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:puffle_tree4 ${x - 2} ${y} ${z - 2}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:puffle_tree4 ${x - 2} ${y} ${z - 2} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:puffle_tree4 ${x - 2} ${y} ${z - 2} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:puffle_tree4 ${x - 2} ${y} ${z - 2} 90_degrees`);
                      }
                    }
                    else {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:puffle_tree5 ${x - 2} ${y} ${z - 2}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:puffle_tree5 ${x - 2} ${y} ${z - 2} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:puffle_tree5 ${x - 2} ${y} ${z - 2} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:puffle_tree5 ${x - 2} ${y} ${z - 2} 90_degrees`);
                      }
                    }
                  }
                  return;
                }
            }
            if (selectedItem?.typeId === 'minecraft:bone_meal') {
                if (e.block.typeId == "azonix:bloom_sapling") {
                  reduceItemAmount(selectedItem, equipment, player);
                  e.block.dimension.playSound('item.bone_meal.use', e.block.location);
                  e.block.dimension.runCommand(`particle minecraft:crop_growth_emitter ${x} ${y} ${z}`);
                  if (randomChance <= 6/10) return;
                  else {
                    block.setPermutation(BlockPermutation.resolve("minecraft:air"));
                    if (randomChance <= 1/8) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:big_bloom_tree1 ${x - 3} ${y} ${z - 6}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:big_bloom_tree1 ${x - 3} ${y} ${z - 6} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:big_bloom_tree1 ${x - 3} ${y} ${z - 6} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:big_bloom_tree1 ${x - 3} ${y} ${z - 6} 90_degrees`);
                      }
                    }
                    else if (randomChance <= 2/8) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:big_bloom_tree2 ${x - 2} ${y} ${z - 5}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:big_bloom_tree2 ${x - 2} ${y} ${z - 5} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:big_bloom_tree2 ${x - 2} ${y} ${z - 5} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:big_bloom_tree2 ${x - 2} ${y} ${z - 5} 90_degrees`);
                      }
                    }
                    else if (randomChance <= 3/8) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree1 ${x - 2} ${y} ${z - 5}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree1 ${x - 2} ${y} ${z - 5} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree1 ${x - 2} ${y} ${z - 5} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree1 ${x - 2} ${y} ${z - 5} 90_degrees`);
                      }
                    }
                    else if (randomChance <= 4/8) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree2 ${x - 2} ${y} ${z - 5}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree2 ${x - 2} ${y} ${z - 5} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree2 ${x - 2} ${y} ${z - 5} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree2 ${x - 2} ${y} ${z - 5} 90_degrees`);
                      }
                    }
                    else if (randomChance <= 5/8) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree3 ${x - 2} ${y} ${z - 5}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree3 ${x - 2} ${y} ${z - 5} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree3 ${x - 2} ${y} ${z - 5} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree3 ${x - 2} ${y} ${z - 5} 90_degrees`);
                      }
                    }
                    else if (randomChance <= 6/8) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree4 ${x - 2} ${y} ${z - 5}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree4 ${x - 2} ${y} ${z - 5} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree4 ${x - 2} ${y} ${z - 5} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree4 ${x - 2} ${y} ${z - 5} 90_degrees`);
                      }
                    }
                    else if (randomChance <= 7/8) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree5 ${x - 2} ${y} ${z - 5}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree5 ${x - 2} ${y} ${z - 5} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree5 ${x - 2} ${y} ${z - 5} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree5 ${x - 2} ${y} ${z - 5} 90_degrees`);
                      }
                    }
                    else {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree6 ${x - 2} ${y} ${z - 2}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree6 ${x - 2} ${y} ${z - 2} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree6 ${x - 2} ${y} ${z - 2} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:bloom_tree6 ${x - 2} ${y} ${z - 2} 90_degrees`);
                      }
                    }
                  }
                  return;
                }
            }
            if (selectedItem?.typeId === 'minecraft:bone_meal') {
                if (e.block.typeId == "azonix:engrove_mushroom") {
                  reduceItemAmount(selectedItem, equipment, player);
                  e.block.dimension.playSound('item.bone_meal.use', e.block.location);
                  e.block.dimension.runCommand(`particle minecraft:crop_growth_emitter ${x} ${y} ${z}`);
                  if (randomChance <= 6/10) return;
                  else {
                    block.setPermutation(BlockPermutation.resolve("minecraft:air"));
                    if (randomChance <= 1/7) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:big_engrove_tree1 ${x - 2} ${y} ${z - 2}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:big_engrove_tree1 ${x - 2} ${y} ${z - 2} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:big_engrove_tree1 ${x - 2} ${y} ${z - 2} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:big_engrove_tree1 ${x - 2} ${y} ${z - 2} 90_degrees`);
                      }
                    }
                    if (randomChance <= 2/7) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:big_engrove_tree2 ${x - 2} ${y} ${z - 2}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:big_engrove_tree2 ${x - 2} ${y} ${z - 2} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:big_engrove_tree2 ${x - 2} ${y} ${z - 2} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:big_engrove_tree2 ${x - 2} ${y} ${z - 2} 90_degrees`);
                      }
                    }
                    else if (randomChance <= 3/7) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:small_engrove_tree ${x - 2} ${y} ${z - 5}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:small_engrove_tree ${x - 2} ${y} ${z - 5} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:small_engrove_tree ${x - 2} ${y} ${z - 5} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:small_engrove_tree ${x - 2} ${y} ${z - 5} 90_degrees`);
                      }
                    }
                    else if (randomChance <= 4/7) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree ${x - 2} ${y} ${z - 5}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree ${x - 2} ${y} ${z - 5} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree ${x - 2} ${y} ${z - 5} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree ${x - 2} ${y} ${z - 5} 90_degrees`);
                      }
                    }
                    else if (randomChance <= 5/7) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree1 ${x - 2} ${y} ${z - 5}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree1 ${x - 2} ${y} ${z - 5} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree1 ${x - 2} ${y} ${z - 5} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree1 ${x - 2} ${y} ${z - 5} 90_degrees`);
                      }
                    }
                    else if (randomChance <= 6/7) {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree2 ${x - 2} ${y} ${z - 5}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree2 ${x - 2} ${y} ${z - 5} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree2 ${x - 2} ${y} ${z - 5} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree2 ${x - 2} ${y} ${z - 5} 90_degrees`);
                      }
                    }
                    else {
                      if (randomChance <= 1/4) {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree3 ${x - 2} ${y} ${z - 5}`);
                      }
                      else if (randomChance <= 2/4) {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree3 ${x - 2} ${y} ${z - 5} 180_degrees`);
                      }
                      else if (randomChance <= 3/4) {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree3 ${x - 2} ${y} ${z - 5} 270_degrees`);
                      }
                      else {
                        e.block.dimension.runCommand(`structure load mystructure:engrove_tree3 ${x - 2} ${y} ${z - 5} 90_degrees`);
                      }
                    }
                  }
                  return;
                }
            }
            if (selectedItem?.typeId === 'minecraft:bone_meal' && aboveBlock.isAir) {
                if (e.block.typeId == "azonix:engrove_clover") {
                  reduceItemAmount(selectedItem, equipment, player);
                  e.block.dimension.playSound('item.bone_meal.use', e.block.location);
                  e.block.dimension.runCommand(`particle minecraft:crop_growth_emitter ${x} ${y} ${z}`);
                  e.block.dimension.runCommand(`setblock ${x} ${y} ${z} azonix:engrove_vine_body`);
                  e.block.dimension.runCommand(`setblock ${x} ${y + 1} ${z} azonix:engrove_clover`);
                  return;
                }
            }
            if (selectedItem?.typeId === 'azonix:engrove_vine' && aboveBlock.isAir) {
                if (e.block.typeId == "azonix:engrove_clover") {
                  reduceItemAmount(selectedItem, equipment, player);
                  e.block.dimension.playSound('dig.grass', e.block.location);
                  e.block.dimension.runCommand(`setblock ${x} ${y} ${z} azonix:engrove_vine_body`);
                  e.block.dimension.runCommand(`setblock ${x} ${y + 1} ${z} azonix:engrove_clover`);
                  return;
                }
            }
            if (selectedItem?.typeId === 'azonix:spectral_growth' && aboveBlock.isAir) {
                if (e.block.typeId == "azonix:spectral_growth_head") {
                  reduceItemAmount(selectedItem, equipment, player);
                  e.block.dimension.playSound('break.sculk', e.block.location);
                  e.block.dimension.runCommand(`setblock ${x} ${y} ${z} azonix:spectral_growth_body`);
                  e.block.dimension.runCommand(`setblock ${x} ${y + 1} ${z} azonix:spectral_growth_head`);
                  return;
                }
            }
            if (selectedItem?.typeId === 'minecraft:bone_meal' && belowBlock.isAir) {
                if (e.block.typeId == "azonix:jakra_vine_head") {
                  reduceItemAmount(selectedItem, equipment, player);
                  e.block.dimension.playSound('item.bone_meal.use', e.block.location);
                  e.block.dimension.runCommand(`particle minecraft:crop_growth_emitter ${x} ${y} ${z}`);
                  e.block.dimension.runCommand(`setblock ${x} ${y} ${z} azonix:jakra_vine_body`);
                  e.block.dimension.runCommand(`setblock ${x} ${y - 1} ${z} azonix:jakra_vine_head`);
                  return;
                }
            }
            if (selectedItem?.typeId === 'azonix:jakra_vine' && belowBlock.isAir) {
                if (e.block.typeId == "azonix:jakra_vine_head") {
                  reduceItemAmount(selectedItem, equipment, player);
                  e.block.dimension.playSound('dig.grass', e.block.location);
                  e.block.dimension.runCommand(`setblock ${x} ${y} ${z} azonix:jakra_vine_body`);
                  e.block.dimension.runCommand(`setblock ${x} ${y - 1} ${z} azonix:jakra_vine_head`);
                  return;
                }
            }
            if (selectedItem?.typeId === 'minecraft:bone_meal' && belowBlock.isAir && belowBlockOne.isAir) {
                if (e.block.typeId == "azonix:bounce_flower") {
                  reduceItemAmount(selectedItem, equipment, player);
                  e.block.dimension.playSound('item.bone_meal.use', e.block.location);
                  e.block.dimension.runCommand(`particle minecraft:crop_growth_emitter ${x} ${y} ${z}`);
                  e.block.dimension.runCommand(`setblock ${x} ${y + 1} ${z} azonix:bounce_vine_body`);
                  e.block.dimension.runCommand(`setblock ${x} ${y} ${z} azonix:bounce_vine_head`);
                  return;
                }
            }
            if (selectedItem?.typeId === 'azonix:bounce_vine' && belowBlock.isAir && belowBlockOne.isAir) {
                if (e.block.typeId == "azonix:bounce_flower") {
                  reduceItemAmount(selectedItem, equipment, player);
                  e.block.dimension.playSound('dig.grass', e.block.location);
                  e.block.dimension.runCommand(`setblock ${x} ${y + 1} ${z} azonix:bounce_vine_body`);
                  e.block.dimension.runCommand(`setblock ${x} ${y} ${z} azonix:bounce_vine_head`);
                  return;
                }
            }
        },
        onPlace: e => {
            const { block } = e;
            const { x, y, z } = block.location;
            const belowBlock = block.below();
            if (e.block.typeId === 'azonix:bounce_vine_head') {
                if (belowBlock.isAir) {
                  e.block.dimension.runCommand(`setblock ${x} ${y - 1} ${z} azonix:bounce_flower`);
                }
                else if (!belowBlock.isAir) {
                  e.block.dimension.runCommand(`setblock ${x} ${y} ${z} air`);
                }
            }
            return;
        },
    });
});
function reduceItemAmount(item, equipment, player) {
    if (player.getGameMode() !== 'creative') {
        if (item.amount > 1) {
            item.amount -= 1;
            equipment.setEquipment('Mainhand', item);
        } else if (item.amount === 1) {
            equipment.setEquipment('Mainhand', undefined);
        }
    }
}