import { world, BlockPermutation } from "@minecraft/server"

const tallPlants = [
    { 
        id: "azonix:chorus_bush_bottom",
        topBit: {
            id: "azonix:chorus_bush_top"
        }
    },
    {
        id: "azonix:tall_rafflesia_bottom",
        topBit: {
            id: "azonix:tall_rafflesia_top"
        }
    },
    {
        id: "azonix:frobo_fern_bottom",
        topBit: {
            id: "azonix:frobo_fern_top"
        }
    },
    {
        id: "azonix:frobo_coral_bottom",
        topBit: {
            id: "azonix:frobo_coral_top"
        }
    },
    {
        id: "azonix:corpse_flower_bottom",
        topBit: {
            id: "azonix:corpse_flower_top"
        }
    },
    {
        id: "azonix:jam_coral_bottom",
        topBit: {
            id: "azonix:jam_coral_top"
        }
    }
]

world.afterEvents.playerPlaceBlock.subscribe(ev => {
    const above = ev.block.above();

    const matchingBottomPlant = tallPlants.find((plant) => ev.block.permutation.matches(plant.id));

    if (matchingBottomPlant != undefined && above.isAir) {
        const matchingTopPlantId = matchingBottomPlant.topBit.id;
        above.setPermutation(BlockPermutation.resolve(matchingTopPlantId));
    } else if (matchingBottomPlant != undefined && !above.isAir) {
        const { x, y, z } = ev.block.location;
        ev.dimension.runCommand(`setblock ${x} ${y} ${z} air[] destroy`);
    }
})

world.afterEvents.playerBreakBlock.subscribe(ev => {
    const matchingTopPlant = tallPlants.find((plant) => ev.brokenBlockPermutation.matches(plant.topBit.id));
    if (matchingTopPlant) {
        const { x, y, z } = ev.block.location;
        ev.dimension.runCommand(`setblock ${x} ${y - 1} ${z} air[] destroy`);
    }
})
